﻿Type=Class
Version=2.2
B4J=true
@EndOfDesignText@
' File: WebAppLogin.bas
' Module Type: WebSocket class
' Purpose: Manage Login
' Changed: See readme.txt
' 
Sub Class_Globals
	Private ws As WebSocket
	
	' Selector Labels
	Private lblapptitle As JQueryElement	' Title shown in the table header
	Private lblappcontent As JQueryElement	' Placeholder for showing the content depending on the user
	Private lblappfooter As JQueryElement	' Footer shown in the table footer
	Private lblabout As JQueryElement		' Abouttext shown in the jQM About Dialog 
	Private tblmain As JQueryElement		' Table listing the events
	
	' Dialogs
	Private dlglogin As JQueryElement
	Private dlgmessage As JQueryElement

	' jQM Message Dialog (see index.html)
	Private messageheader As JQueryElement
	Private messagecontent As JQueryElement

	Private eventid As JQueryElement
	Private eventinformation As JQueryElement
	Private eventinformationp As JQueryElement
	Private eventparticipant As JQueryElement

	Private gstrUsername As String
	Private username As JQueryElement
	Private password As JQueryElement
End Sub

Public Sub Initialize
	
End Sub

' Websockets gets connected by the user
Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	DateTime.DateFormat = "dd.MM.yyyy"
	Main.AppLog("WebSocket_Connected :: Start")
	'
	' Get the websocket first
	ws = WebSocket1
	'
	' Update app version and the datetoday labels in the Index.html - these are defined linke <div id="lbldatetoday"></div>
	lblapptitle.SetText(Main.CAPPTITLE)
	lblappcontent.SetHtml("No content shown as not logged in!<BR>Login first.")
	lblappfooter.SetText("Today is " & DateTime.Date(DateTime.Now)& " | You are not logged in.")
	lblabout.SetText(Main.CAPPTITLE & " " & Main.CAPPDESCRIPTION & " " & Main.CAPPVERSION & " " & Main.CAPPCOPYRIGHT)
	'
	Main.AppLog("WebSocket_Connected :: End")
End Sub

Private Sub WebSocket_Disconnected

End Sub

' Show Message using jquery mobile dialog - see index.html
' Parameter Header as HTML string
' Parameter Message as HTML String
Sub showMessage(hdr As String, msg As String)
	' Set the message selector
	messageheader.SetHtml(hdr)
	messagecontent.SetHtml(msg)
	' Show the dialog
	ws.RunFunction("OpenDialog", Array As String(dlgmessage.Id))
End Sub

' Show about using showMessage dialog
Sub about_event(Params As Map)
	' Option 1 using Alert method from the websocket
	' ws.Alert(Main.CAPPTITLE & " " & Main.CAPPDESCRIPTION & " " & Main.CAPPVERSION & " " & Main.CAPPCOPYRIGHT & " " & Main.CINTERNET)
	'
	' Option 2 using sub showMessage which is build upon jQuery dialog - see index.html
	showMessage("About...", "<H1>" & Main.CAPPTITLE & " " & Main.CAPPVERSION & "</H1>" & Main.CAPPDESCRIPTION & "<BR>" & Main.CAPPCOPYRIGHT)
End Sub


' Handle OK from the Login Dialog
' Assign username to global var
' TODO: Check in SQLite DB if username is valid
Sub login_event(Params As Map)
	Main.AppLog("login_event :: Start - [Username: " & Params.get("username") & "]")
	If Params.get("action") = "yes" Then setUserSessionAttributes(Params.get("username"), Params.get("password"))
	Main.AppLog("login_event :: End")
End Sub

' Check username and password
' Return True if found in the JSON file located in the webapp folder
' TODO: Lookup for user via loop can be optimized
Sub checkLogin(uname As String, pword As String) As Boolean
	Dim result As Boolean = False
	Dim parser As JSONParser
	parser.Initialize(File.ReadString(File.DirApp, "users.json"))
	Dim root As List = parser.NextArray
	For Each colroot As Map In root
 		Dim musername As String = colroot.Get("username")
 		Dim mpassword As String = colroot.Get("password")
		If (musername.CompareTo(uname) = 0) AND (mpassword.CompareTo(pword) = 0) Then
			result = True
		End If
	Next 
	Return result
End Sub

' Get the user information from table members and set the session attributes accordingly
' Parameter: Username
' Parameter: Password - NOT USED FOR NOW
Sub setUserSessionAttributes(uname As String, pword As String)
	Main.AppLog("getUserSessionAttributes :: Start: Username=" & uname)

	' Reset websocket attributes first
	' username.SetText("")
	ws.Session.SetAttribute("login", False)
	ws.Session.SetAttribute("manager", False)
	ws.Session.SetAttribute("username", "")
	'
	Try
		' Select the user from the json file
		If checkLogin(uname, pword) = True Then
			' Set session attributes
			ws.Session.SetAttribute("username", uname)
			ws.Session.SetAttribute("login", True)
			gstrUsername = uname
			username.SetText(gstrUsername)
			lblappfooter.SetText("Today is " & DateTime.Date(DateTime.Now)& " - You are logged in as " & gstrUsername & ".")
			setUserContent(uname)
		Else
			ws.alert("Error" & CRLF & "Invalid Username and/or Password entered!. Please login again.")	
		End If
	Catch
		Log(LastException.message)
	End Try
	'
	Main.AppLog("getUserSessionAttributes :: End")
End Sub

' Sets the user content depending on the username
Sub setUserContent(uname As String)
	Select uname
		Case "user1"
			lblappcontent.SetHTML("Hi " & uname & ", <BR><font color=""red"">This is your content.</font>")		
		Case "user2"
			lblappcontent.SetHTML("Hi " & uname & ", <BR><font color=""blue"">This is your content.</font><Hr>Enjoy")		
	End Select
End Sub
