﻿Type=StaticCode
Version=2.2
B4J=true
@EndOfDesignText@

Sub Process_Globals
	
End Sub

Public Sub EscapeHtml(Raw As String) As String
   Dim sb As StringBuilder
   sb.Initialize
   For i = 0 To Raw.Length - 1
     Dim C As Char = Raw.CharAt(i)
     Select C
       Case CRLF
         sb.Append("<BR>")
		Case Chr(9)
         sb.Append("&nbsp;&nbsp;")
	   Case QUOTE
         sb.Append("&quot;")
       Case "'"
         sb.Append("&#39;")
       Case "<"
         sb.Append("&lt;")
       Case ">"
         sb.Append("&gt;")
       Case "&"
         sb.Append("&amp;")
       Case "ö"
         sb.Append("&ouml;")
       Case "ä"
         sb.Append("&auml;")
       Case "ü"
         sb.Append("&uuml;")
       Case "Ö"
         sb.Append("&Ouml;")
       Case "Ä"
         sb.Append("&Auml;")
       Case "Ü"
         sb.Append("&Uuml;")
       Case "ß"
         sb.Append("&szlig;")
       Case Else
         sb.Append(C)
     End Select
   Next
   Return sb.ToString
End Sub

Public Sub ReplaceMap(Base As String, Replacements As Map) As String
	For i = 0 To Replacements.Size - 1
		Base = Base.Replace("$" & Replacements.GetKeyAt(i) & "$", Replacements.GetValueAt(i))
	Next
	Return Base
End Sub

Public Sub EscapeURL(Raw As String) As String
   Dim sb As StringBuilder
   sb.Initialize
   For i = 0 To Raw.Length - 1
     Dim C As Char = Raw.CharAt(i)
	 Select C
       Case CRLF
         sb.Append("%0A")
         'sb.Append("%0A%0D")
		Case Chr(0)
         	sb.Append("%20")
		Case Chr(32)
         	sb.Append("%20")
		Case "!" 	
			sb.Append("%21")
		Case """"
			sb.Append("%22")
		Case "#" 	
			sb.Append("%23")
		Case "$" 	
			sb.Append("%24")
		Case "%" 	
			sb.Append("%25")
		Case "&" 	
			sb.Append("%26")
		Case "'" 	
			sb.Append("%27")
		Case "(" 	
			sb.Append("%28")
		Case ")" 	
			sb.Append("%29")
		Case "*" 	
			sb.Append("%2A")
		Case "+" 	
			sb.Append("%2B")
		Case "," 	
			sb.Append("%2C")
		Case "/" 	
			sb.Append("%2F")
		Case ":" 	
			sb.Append("%3A")
		Case ";" 	
			sb.Append("%3B")
		Case "=" 	
			sb.Append("%3D")
		Case "?" 	
			sb.Append("%3F")
		Case "@" 	
			sb.Append("%40")
		Case "[" 	
			sb.Append("%5B")
		Case "]" 	
			sb.Append("%5D")
		Case "<"
			sb.Append("%3C")
		Case ">"
			sb.Append("%3E")
		 Case "-"
			sb.Append("%20")

		' UMLAUTE
		Case "Ä"
			sb.Append("%C3%84")
		Case "ä"
			sb.Append("%C3%A4")
		Case "Ö"
			sb.Append("%C3%96")
		Case "ö"
			sb.Append("%C3%B6")
		Case "Ü"
			sb.Append("%C3%9C")
		Case "ü"
			sb.Append("%C3%BC")
		Case "ß"
			sb.Append("%C3%9F")
       	Case Else
         	sb.Append(C)
     End Select
   Next
   Return sb.ToString
End Sub

Public Sub RedirectTo(ws As WebSocket, TargetUrl As String)
	ws.Eval("window.location = arguments[0]", Array As Object(TargetUrl))
End Sub